/* test-class-signal.c generated by valac 0.14.0, the Vala compiler
 * generated from test-class-signal.vala, do not modify */

/*
 * Copyright (C) 2008, Nokia <ivan.frade@nokia.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <libtracker-sparql/tracker-sparql.h>
#include <gobject/gvaluecollector.h>


#define TYPE_EVENT (event_get_type ())
typedef struct _Event Event;

#define TYPE_RESOURCES (resources_get_type ())
#define RESOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESOURCES, Resources))
#define IS_RESOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESOURCES))
#define RESOURCES_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_RESOURCES, ResourcesIface))

typedef struct _Resources Resources;
typedef struct _ResourcesIface ResourcesIface;

#define TYPE_RESOURCES_PROXY (resources_proxy_get_type ())
typedef GDBusProxy ResourcesProxy;
typedef GDBusProxyClass ResourcesProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_TEST_APP (test_app_get_type ())
#define TEST_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEST_APP, TestApp))
#define TEST_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEST_APP, TestAppClass))
#define IS_TEST_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEST_APP))
#define IS_TEST_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEST_APP))
#define TEST_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEST_APP, TestAppClass))

typedef struct _TestApp TestApp;
typedef struct _TestAppClass TestAppClass;
typedef struct _TestAppPrivate TestAppPrivate;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _test_app_unref0(var) ((var == NULL) ? NULL : (var = (test_app_unref (var), NULL)))
typedef struct _TestAppOnGraphUpdatedReceivedAsyncData TestAppOnGraphUpdatedReceivedAsyncData;
typedef struct _ParamSpecTestApp ParamSpecTestApp;

struct _Event {
	gint graph_id;
	gint subject_id;
	gint pred_id;
	gint object_id;
};

struct _ResourcesIface {
	GTypeInterface parent_iface;
	void (*sparql_update_async) (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*sparql_update_finish) (Resources* self, GAsyncResult* _res_, GError** error);
};

struct _TestApp {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TestAppPrivate * priv;
};

struct _TestAppClass {
	GTypeClass parent_class;
	void (*finalize) (TestApp *self);
};

struct _TestAppPrivate {
	gint res;
	GMainLoop* loop;
	gboolean initialized;
	TrackerSparqlConnection* signal_con;
	TrackerSparqlConnection* con;
	gint total_signals_seen;
};

struct _TestAppOnGraphUpdatedReceivedAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	TestApp* self;
	gchar* dels_query;
	gchar* ins_query;
	TrackerSparqlCursor* cursor1;
	TrackerSparqlCursor* cursor2;
	TrackerSparqlConnection* _tmp0_;
	const gchar* _tmp1_;
	TrackerSparqlCursor* _tmp2_;
	TrackerSparqlCursor* _tmp3_;
	TrackerSparqlConnection* _tmp4_;
	const gchar* _tmp5_;
	TrackerSparqlCursor* _tmp6_;
	TrackerSparqlCursor* _tmp7_;
	TrackerSparqlCursor* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	TrackerSparqlCursor* _tmp11_;
	gint _tmp12_;
	GError* e;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError * _inner_error_;
};

struct _ParamSpecTestApp {
	GParamSpec parent_instance;
};


static gpointer test_app_parent_class = NULL;
static Resources* test_app_resources_object;
static Resources* test_app_resources_object = NULL;

#define max_signals 10
#define title_data "title"
GType event_get_type (void) G_GNUC_CONST;
Event* event_dup (const Event* self);
void event_free (Event* self);
GType resources_proxy_get_type (void) G_GNUC_CONST;
guint resources_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType resources_get_type (void) G_GNUC_CONST;
void resources_sparql_update_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
void resources_sparql_update_finish (Resources* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void resources_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_resources_graph_updated (Resources* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void resources_proxy_sparql_update_async_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void resources_proxy_sparql_update_async_finish (Resources* self, GAsyncResult* _res_, GError** error);
static void resources_proxy_resources_interface_init (ResourcesIface* iface);
static void _dbus_resources_sparql_update_async (Resources* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_resources_sparql_update_async_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void resources_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* resources_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean resources_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_resources_graph_updated (GObject* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer* _data);
static void _resources_unregister_object (gpointer user_data);
gpointer test_app_ref (gpointer instance);
void test_app_unref (gpointer instance);
GParamSpec* param_spec_test_app (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_test_app (GValue* value, gpointer v_object);
void value_take_test_app (GValue* value, gpointer v_object);
gpointer value_get_test_app (const GValue* value);
GType test_app_get_type (void) G_GNUC_CONST;
#define TEST_APP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEST_APP, TestAppPrivate))
enum  {
	TEST_APP_DUMMY_PROPERTY
};
TestApp* test_app_new (void);
TestApp* test_app_construct (GType object_type);
static void test_app_on_graph_updated_received (TestApp* self, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1);
static void _test_app_on_graph_updated_received_resources_graph_updated (Resources* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer self);
static GString* test_app_build_title_query (TestApp* self, const gchar* class_name, Event* ids, int ids_length1);
static gint test_app_iter_cursor (TestApp* self, const gchar* kind, TrackerSparqlCursor* cursor);
static void test_app_on_graph_updated_received_async_data_free (gpointer _data);
static void test_app_on_graph_updated_received_async (TestApp* self, const gchar* dels_query, const gchar* ins_query, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void test_app_on_graph_updated_received_finish (TestApp* self, GAsyncResult* _res_);
static gboolean test_app_on_graph_updated_received_async_co (TestAppOnGraphUpdatedReceivedAsyncData* _data_);
static void test_app_on_graph_updated_received_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void test_app_insert_data (TestApp* self);
static gboolean test_app_in_mainloop (TestApp* self);
gint test_app_run (TestApp* self);
static gboolean _test_app_in_mainloop_gsource_func (gpointer self);
static void test_app_finalize (TestApp* obj);
gint _vala_main (gchar** args, int args_length1);

static const GDBusArgInfo _resources_dbus_arg_info_sparql_update_async_query = {-1, "query", "s"};
static const GDBusArgInfo * const _resources_dbus_arg_info_sparql_update_async_in[] = {&_resources_dbus_arg_info_sparql_update_async_query, NULL};
static const GDBusArgInfo * const _resources_dbus_arg_info_sparql_update_async_out[] = {NULL};
static const GDBusMethodInfo _resources_dbus_method_info_sparql_update_async = {-1, "SparqlUpdate", (GDBusArgInfo **) (&_resources_dbus_arg_info_sparql_update_async_in), (GDBusArgInfo **) (&_resources_dbus_arg_info_sparql_update_async_out)};
static const GDBusMethodInfo * const _resources_dbus_method_info[] = {&_resources_dbus_method_info_sparql_update_async, NULL};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_class_name = {-1, "class_name", "s"};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_deletes = {-1, "deletes", "a(iiii)"};
static const GDBusArgInfo _resources_dbus_arg_info_graph_updated_inserts = {-1, "inserts", "a(iiii)"};
static const GDBusArgInfo * const _resources_dbus_arg_info_graph_updated[] = {&_resources_dbus_arg_info_graph_updated_class_name, &_resources_dbus_arg_info_graph_updated_deletes, &_resources_dbus_arg_info_graph_updated_inserts, NULL};
static const GDBusSignalInfo _resources_dbus_signal_info_graph_updated = {-1, "GraphUpdated", (GDBusArgInfo **) (&_resources_dbus_arg_info_graph_updated)};
static const GDBusSignalInfo * const _resources_dbus_signal_info[] = {&_resources_dbus_signal_info_graph_updated, NULL};
static const GDBusPropertyInfo * const _resources_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _resources_dbus_interface_info = {-1, "org.freedesktop.Tracker1.Resources", (GDBusMethodInfo **) (&_resources_dbus_method_info), (GDBusSignalInfo **) (&_resources_dbus_signal_info), (GDBusPropertyInfo **) (&_resources_dbus_property_info)};
static const GDBusInterfaceVTable _resources_dbus_interface_vtable = {resources_dbus_interface_method_call, resources_dbus_interface_get_property, resources_dbus_interface_set_property};

Event* event_dup (const Event* self) {
	Event* dup;
#line 27 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	dup = g_new0 (Event, 1);
#line 27 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	memcpy (dup, self, sizeof (Event));
#line 27 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return dup;
#line 214 "test-class-signal.c"
}


void event_free (Event* self) {
#line 27 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_free (self);
#line 221 "test-class-signal.c"
}


GType event_get_type (void) {
	static volatile gsize event_type_id__volatile = 0;
	if (g_once_init_enter (&event_type_id__volatile)) {
		GType event_type_id;
		event_type_id = g_boxed_type_register_static ("Event", (GBoxedCopyFunc) event_dup, (GBoxedFreeFunc) event_free);
		g_once_init_leave (&event_type_id__volatile, event_type_id);
	}
	return event_type_id__volatile;
}


void resources_sparql_update_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	RESOURCES_GET_INTERFACE (self)->sparql_update_async (self, query, _callback_, _user_data_);
#line 239 "test-class-signal.c"
}


void resources_sparql_update_finish (Resources* self, GAsyncResult* _res_, GError** error) {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	RESOURCES_GET_INTERFACE (self)->sparql_update_finish (self, _res_, error);
#line 246 "test-class-signal.c"
}


static void g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT) (gpointer data1, const char* arg_1, gpointer arg_2, gint arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (n_param_values == 6);
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		data1 = closure->data;
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		data2 = param_values->data[0].v_pointer;
#line 265 "test-class-signal.c"
	} else {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		data1 = param_values->data[0].v_pointer;
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		data2 = closure->data;
#line 271 "test-class-signal.c"
	}
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER_INT_POINTER_INT) (marshal_data ? marshal_data : cc->callback);
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), g_value_get_int (param_values + 3), g_value_get_pointer (param_values + 4), g_value_get_int (param_values + 5), data2);
#line 277 "test-class-signal.c"
}


static void resources_base_init (ResourcesIface * iface) {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	static gboolean initialized = FALSE;
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (!initialized) {
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		initialized = TRUE;
#line 35 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_signal_new ("graph_updated", TYPE_RESOURCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER_INT_POINTER_INT, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_POINTER, G_TYPE_INT);
#line 290 "test-class-signal.c"
	}
}


GType resources_get_type (void) {
	static volatile gsize resources_type_id__volatile = 0;
	if (g_once_init_enter (&resources_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ResourcesIface), (GBaseInitFunc) resources_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType resources_type_id;
		resources_type_id = g_type_register_static (G_TYPE_INTERFACE, "Resources", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (resources_type_id, G_TYPE_DBUS_PROXY);
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) resources_proxy_get_type);
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Tracker1.Resources");
		g_type_set_qdata (resources_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) resources_register_object);
		g_once_init_leave (&resources_type_id__volatile, resources_type_id);
	}
	return resources_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ResourcesProxy, resources_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_RESOURCES, resources_proxy_resources_interface_init) )
static void resources_proxy_class_init (ResourcesProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = resources_proxy_g_signal;
}


static void _dbus_handle_resources_graph_updated (Resources* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* class_name = NULL;
	GVariant* _tmp0_;
	Event* deletes = NULL;
	int deletes_length1;
	GVariant* _tmp1_;
	Event* _tmp2_;
	int _tmp2__length;
	int _tmp2__size;
	int _tmp2__length1;
	GVariantIter _tmp3_;
	GVariant* _tmp4_;
	Event* inserts = NULL;
	int inserts_length1;
	GVariant* _tmp11_;
	Event* _tmp12_;
	int _tmp12__length;
	int _tmp12__size;
	int _tmp12__length1;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	class_name = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	deletes_length1 = 0;
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp2_ = g_new (Event, 5);
	_tmp2__length = 0;
	_tmp2__size = 4;
	_tmp2__length1 = 0;
	g_variant_iter_init (&_tmp3_, _tmp1_);
	for (; (_tmp4_ = g_variant_iter_next_value (&_tmp3_)) != NULL; _tmp2__length1++) {
		Event _tmp5_;
		GVariantIter _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		if (_tmp2__size == _tmp2__length) {
			_tmp2__size = 2 * _tmp2__size;
			_tmp2_ = g_renew (Event, _tmp2_, _tmp2__size + 1);
		}
		g_variant_iter_init (&_tmp6_, _tmp4_);
		_tmp7_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.graph_id = g_variant_get_int32 (_tmp7_);
		g_variant_unref (_tmp7_);
		_tmp8_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.subject_id = g_variant_get_int32 (_tmp8_);
		g_variant_unref (_tmp8_);
		_tmp9_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.pred_id = g_variant_get_int32 (_tmp9_);
		g_variant_unref (_tmp9_);
		_tmp10_ = g_variant_iter_next_value (&_tmp6_);
		_tmp5_.object_id = g_variant_get_int32 (_tmp10_);
		g_variant_unref (_tmp10_);
		_tmp2_[_tmp2__length++] = _tmp5_;
		g_variant_unref (_tmp4_);
	}
	deletes_length1 = _tmp2__length1;
	deletes = _tmp2_;
	g_variant_unref (_tmp1_);
	inserts_length1 = 0;
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp12_ = g_new (Event, 5);
	_tmp12__length = 0;
	_tmp12__size = 4;
	_tmp12__length1 = 0;
	g_variant_iter_init (&_tmp13_, _tmp11_);
	for (; (_tmp14_ = g_variant_iter_next_value (&_tmp13_)) != NULL; _tmp12__length1++) {
		Event _tmp15_;
		GVariantIter _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		if (_tmp12__size == _tmp12__length) {
			_tmp12__size = 2 * _tmp12__size;
			_tmp12_ = g_renew (Event, _tmp12_, _tmp12__size + 1);
		}
		g_variant_iter_init (&_tmp16_, _tmp14_);
		_tmp17_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.graph_id = g_variant_get_int32 (_tmp17_);
		g_variant_unref (_tmp17_);
		_tmp18_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.subject_id = g_variant_get_int32 (_tmp18_);
		g_variant_unref (_tmp18_);
		_tmp19_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.pred_id = g_variant_get_int32 (_tmp19_);
		g_variant_unref (_tmp19_);
		_tmp20_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.object_id = g_variant_get_int32 (_tmp20_);
		g_variant_unref (_tmp20_);
		_tmp12_[_tmp12__length++] = _tmp15_;
		g_variant_unref (_tmp14_);
	}
	inserts_length1 = _tmp12__length1;
	inserts = _tmp12_;
	g_variant_unref (_tmp11_);
	g_signal_emit_by_name (self, "graph-updated", class_name, deletes, deletes_length1, inserts, inserts_length1);
	_g_free0 (class_name);
	deletes = (g_free (deletes), NULL);
	inserts = (g_free (inserts), NULL);
}


static void resources_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "GraphUpdated") == 0) {
		_dbus_handle_resources_graph_updated ((Resources*) proxy, parameters);
	}
}


static void resources_proxy_init (ResourcesProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void resources_proxy_sparql_update_async_async (Resources* self, const gchar* query, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	TRACKER_SPARQL_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Tracker1.Resources", "SparqlUpdate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (query));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void resources_proxy_sparql_update_async_finish (Resources* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void resources_proxy_resources_interface_init (ResourcesIface* iface) {
	iface->sparql_update_async = resources_proxy_sparql_update_async_async;
	iface->sparql_update_finish = resources_proxy_sparql_update_async_finish;
}


static void _dbus_resources_sparql_update_async (Resources* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* query = NULL;
	GVariant* _tmp21_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	query = g_variant_dup_string (_tmp21_, NULL);
	g_variant_unref (_tmp21_);
	resources_sparql_update_async (self, query, (GAsyncReadyCallback) _dbus_resources_sparql_update_async_ready, invocation);
	_g_free0 (query);
}


static void _dbus_resources_sparql_update_async_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	resources_sparql_update_finish ((Resources*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void resources_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "SparqlUpdate") == 0) {
		_dbus_resources_sparql_update_async (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* resources_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean resources_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_resources_graph_updated (GObject* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	Event* _tmp22_;
	GVariantBuilder _tmp23_;
	int _tmp24_;
	Event* _tmp26_;
	GVariantBuilder _tmp27_;
	int _tmp28_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (class_name));
	_tmp22_ = deletes;
	g_variant_builder_init (&_tmp23_, G_VARIANT_TYPE ("a(iiii)"));
	for (_tmp24_ = 0; _tmp24_ < deletes_length1; _tmp24_++) {
		GVariantBuilder _tmp25_;
		g_variant_builder_init (&_tmp25_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).graph_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).subject_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).pred_id));
		g_variant_builder_add_value (&_tmp25_, g_variant_new_int32 ((*_tmp22_).object_id));
		g_variant_builder_add_value (&_tmp23_, g_variant_builder_end (&_tmp25_));
		_tmp22_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp23_));
	_tmp26_ = inserts;
	g_variant_builder_init (&_tmp27_, G_VARIANT_TYPE ("a(iiii)"));
	for (_tmp28_ = 0; _tmp28_ < inserts_length1; _tmp28_++) {
		GVariantBuilder _tmp29_;
		g_variant_builder_init (&_tmp29_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).graph_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).subject_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).pred_id));
		g_variant_builder_add_value (&_tmp29_, g_variant_new_int32 ((*_tmp26_).object_id));
		g_variant_builder_add_value (&_tmp27_, g_variant_builder_end (&_tmp29_));
		_tmp26_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp27_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Tracker1.Resources", "GraphUpdated", _arguments, NULL);
}


guint resources_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_resources_dbus_interface_info), &_resources_dbus_interface_vtable, data, _resources_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "graph-updated", (GCallback) _dbus_resources_graph_updated, data);
	return result;
}


static void _resources_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_resources_graph_updated, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static gpointer _g_object_ref0 (gpointer self) {
#line 58 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return self ? g_object_ref (self) : NULL;
#line 620 "test-class-signal.c"
}


static void _test_app_on_graph_updated_received_resources_graph_updated (Resources* _sender, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1, gpointer self) {
#line 65 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_on_graph_updated_received (self, class_name, deletes, deletes_length1, inserts, inserts_length1);
#line 627 "test-class-signal.c"
}


TestApp* test_app_construct (GType object_type) {
	TestApp* self = NULL;
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
#line 52 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self = (TestApp*) g_type_create_instance (object_type);
#line 52 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = self->priv->initialized;
#line 52 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (!_tmp0_, NULL);
#line 641 "test-class-signal.c"
	{
		TrackerSparqlConnection* _tmp1_ = NULL;
		TrackerSparqlConnection* _tmp2_;
		TrackerSparqlConnection* _tmp3_;
		TrackerSparqlConnection* _tmp4_;
		Resources* _tmp5_ = NULL;
		Resources* _tmp6_;
		Resources* _tmp7_;
#line 55 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp1_ = tracker_sparql_connection_get (NULL, &_inner_error_);
#line 55 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp2_ = _tmp1_;
#line 55 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (_inner_error_ != NULL) {
#line 656 "test-class-signal.c"
			goto __catch0_g_error;
		}
#line 55 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (self->priv->con);
#line 55 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		self->priv->con = _tmp2_;
#line 58 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp3_ = self->priv->con;
#line 58 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 58 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (self->priv->signal_con);
#line 58 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		self->priv->signal_con = _tmp4_;
#line 60 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp5_ = g_initable_new (TYPE_RESOURCES_PROXY, NULL, &_inner_error_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_LOAD_PROPERTIES | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, "g-name", "org.freedesktop.Tracker1", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/Tracker1/Resources", "g-interface-name", "org.freedesktop.Tracker1.Resources", NULL);
#line 60 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp6_ = (Resources*) _tmp5_;
#line 60 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (_inner_error_ != NULL) {
#line 677 "test-class-signal.c"
			goto __catch0_g_error;
		}
#line 60 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (test_app_resources_object);
#line 60 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		test_app_resources_object = _tmp6_;
#line 65 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp7_ = test_app_resources_object;
#line 65 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_signal_connect (_tmp7_, "graph-updated", (GCallback) _test_app_on_graph_updated_received_resources_graph_updated, self);
#line 688 "test-class-signal.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		e = _inner_error_;
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_inner_error_ = NULL;
#line 68 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp8_ = e;
#line 68 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp9_ = _tmp8_->message;
#line 68 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_warning ("test-class-signal.vala:68: Could not connect to D-Bus service: %s", _tmp9_);
#line 69 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		self->priv->initialized = FALSE;
#line 70 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		self->priv->res = -1;
#line 71 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_error_free0 (e);
#line 71 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return self;
#line 714 "test-class-signal.c"
	}
	__finally0:
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (_inner_error_ != NULL) {
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_clear_error (&_inner_error_);
#line 54 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return NULL;
#line 725 "test-class-signal.c"
	}
#line 73 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv->initialized = TRUE;
#line 52 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return self;
#line 731 "test-class-signal.c"
}


TestApp* test_app_new (void) {
#line 52 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return test_app_construct (TYPE_TEST_APP);
#line 738 "test-class-signal.c"
}


static GString* test_app_build_title_query (TestApp* self, const gchar* class_name, Event* ids, int ids_length1) {
	GString* result = NULL;
	gboolean first;
	GString* _tmp0_;
	GString* builder;
	GString* _tmp1_;
	const gchar* _tmp2_;
	GString* _tmp3_;
	Event* _tmp4_;
	gint _tmp4__length1;
	GString* _tmp12_;
#line 81 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (class_name != NULL, NULL);
#line 82 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	first = TRUE;
#line 83 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = g_string_new ("SELECT ?r ?t { ?r a <");
#line 83 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	builder = _tmp0_;
#line 84 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1_ = builder;
#line 84 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp2_ = class_name;
#line 84 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_string_append (_tmp1_, _tmp2_);
#line 85 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp3_ = builder;
#line 85 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_string_append (_tmp3_, ">; nie:title ?t . FILTER (tracker:id (?r) IN (");
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp4_ = ids;
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp4__length1 = ids_length1;
#line 777 "test-class-signal.c"
	{
		Event* event_collection = NULL;
		gint event_collection_length1 = 0;
		gint _event_collection_size_ = 0;
		gint event_it = 0;
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		event_collection = _tmp4_;
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		event_collection_length1 = _tmp4__length1;
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		for (event_it = 0; event_it < _tmp4__length1; event_it = event_it + 1) {
#line 789 "test-class-signal.c"
			Event event = {0};
#line 86 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			event = event_collection[event_it];
#line 793 "test-class-signal.c"
			{
				gboolean _tmp5_;
#line 87 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				_tmp5_ = first;
#line 87 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				if (_tmp5_) {
#line 800 "test-class-signal.c"
					GString* _tmp6_;
					Event _tmp7_;
					gint _tmp8_;
#line 88 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp6_ = builder;
#line 88 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp7_ = event;
#line 88 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp8_ = _tmp7_.subject_id;
#line 88 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					g_string_append_printf (_tmp6_, "%d", _tmp8_);
#line 812 "test-class-signal.c"
				} else {
					GString* _tmp9_;
					Event _tmp10_;
					gint _tmp11_;
#line 90 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp9_ = builder;
#line 90 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp10_ = event;
#line 90 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					_tmp11_ = _tmp10_.subject_id;
#line 90 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
					g_string_append_printf (_tmp9_, " , %d", _tmp11_);
#line 825 "test-class-signal.c"
				}
#line 91 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				first = FALSE;
#line 829 "test-class-signal.c"
			}
		}
	}
#line 93 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp12_ = builder;
#line 93 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_string_append (_tmp12_, ")) }");
#line 94 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	result = builder;
#line 94 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 841 "test-class-signal.c"
}


static gint test_app_iter_cursor (TestApp* self, const gchar* kind, TrackerSparqlCursor* cursor) {
	gint result = 0;
	GError * _inner_error_ = NULL;
#line 97 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 97 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (kind != NULL, 0);
#line 97 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (cursor != NULL, 0);
#line 854 "test-class-signal.c"
	{
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		while (TRUE) {
#line 858 "test-class-signal.c"
			TrackerSparqlCursor* _tmp0_;
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_;
			TrackerSparqlCursor* _tmp3_;
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			gchar* resource;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			TrackerSparqlCursor* _tmp8_;
			const gchar* _tmp9_ = NULL;
			gint _tmp10_;
			gint _tmp11_;
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp0_ = cursor;
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp1_ = tracker_sparql_cursor_next (_tmp0_, NULL, &_inner_error_);
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp2_ = _tmp1_;
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			if (_inner_error_ != NULL) {
#line 880 "test-class-signal.c"
				goto __catch1_g_error;
			}
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			if (!_tmp2_) {
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				break;
#line 887 "test-class-signal.c"
			}
#line 100 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp3_ = cursor;
#line 100 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp4_ = tracker_sparql_cursor_get_string (_tmp3_, 0, NULL);
#line 100 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 100 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			resource = _tmp5_;
#line 102 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp6_ = kind;
#line 102 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp7_ = resource;
#line 102 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp8_ = cursor;
#line 102 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp9_ = tracker_sparql_cursor_get_string (_tmp8_, 1, NULL);
#line 102 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			g_print ("%s <%s> nie:title '%s'\n", _tmp6_, _tmp7_, _tmp9_);
#line 106 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp10_ = self->priv->total_signals_seen;
#line 106 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			self->priv->total_signals_seen = _tmp10_ + 1;
#line 110 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp11_ = self->priv->total_signals_seen;
#line 110 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			if (_tmp11_ >= (max_signals * 2)) {
#line 915 "test-class-signal.c"
				GMainLoop* _tmp12_;
#line 111 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				_tmp12_ = self->priv->loop;
#line 111 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				g_main_loop_quit (_tmp12_);
#line 921 "test-class-signal.c"
			}
#line 99 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_free0 (resource);
#line 925 "test-class-signal.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		e = _inner_error_;
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_inner_error_ = NULL;
#line 115 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp13_ = e;
#line 115 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp14_ = _tmp13_->message;
#line 115 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_warning ("test-class-signal.vala:115: Couldn't iterate query results: %s", _tmp14_);
#line 116 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		self->priv->res = -1;
#line 117 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		result = -1;
#line 117 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_error_free0 (e);
#line 117 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return result;
#line 952 "test-class-signal.c"
	}
	__finally1:
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (_inner_error_ != NULL) {
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_clear_error (&_inner_error_);
#line 98 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return 0;
#line 963 "test-class-signal.c"
	}
#line 119 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	result = 0;
#line 119 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 969 "test-class-signal.c"
}


static void test_app_on_graph_updated_received_async_data_free (gpointer _data) {
	TestAppOnGraphUpdatedReceivedAsyncData* _data_;
	_data_ = _data;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_free0 (_data_->dels_query);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_free0 (_data_->ins_query);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_test_app_unref0 (_data_->self);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_slice_free (TestAppOnGraphUpdatedReceivedAsyncData, _data_);
#line 984 "test-class-signal.c"
}


static gpointer _test_app_ref0 (gpointer self) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return self ? test_app_ref (self) : NULL;
#line 991 "test-class-signal.c"
}


static void test_app_on_graph_updated_received_async (TestApp* self, const gchar* dels_query, const gchar* ins_query, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TestAppOnGraphUpdatedReceivedAsyncData* _data_;
	TestApp* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_ = g_slice_new0 (TestAppOnGraphUpdatedReceivedAsyncData);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, test_app_on_graph_updated_received_async);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, test_app_on_graph_updated_received_async_data_free);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = _test_app_ref0 (self);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->self = _tmp0_;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1_ = dels_query;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->dels_query = _tmp2_;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp3_ = ins_query;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->ins_query = _tmp4_;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_on_graph_updated_received_async_co (_data_);
#line 1026 "test-class-signal.c"
}


static void test_app_on_graph_updated_received_finish (TestApp* self, GAsyncResult* _res_) {
	TestAppOnGraphUpdatedReceivedAsyncData* _data_;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 1034 "test-class-signal.c"
}


static void test_app_on_graph_updated_received_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	TestAppOnGraphUpdatedReceivedAsyncData* _data_;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_ = _user_data_;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->_source_object_ = source_object;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_data_->_res_ = _res_;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_on_graph_updated_received_async_co (_data_);
#line 1048 "test-class-signal.c"
}


static gboolean test_app_on_graph_updated_received_async_co (TestAppOnGraphUpdatedReceivedAsyncData* _data_) {
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	switch (_data_->_state_) {
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		case 0:
#line 1057 "test-class-signal.c"
		goto _state_0;
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		case 1:
#line 1061 "test-class-signal.c"
		goto _state_1;
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		case 2:
#line 1065 "test-class-signal.c"
		goto _state_2;
		default:
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_assert_not_reached ();
#line 1070 "test-class-signal.c"
	}
	_state_0:
	{
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp0_ = _data_->self->priv->signal_con;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp1_ = _data_->dels_query;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_state_ = 1;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		tracker_sparql_connection_query_async (_data_->_tmp0_, _data_->_tmp1_, NULL, test_app_on_graph_updated_received_async_ready, _data_);
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return FALSE;
#line 1084 "test-class-signal.c"
		_state_1:
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp2_ = NULL;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp2_ = tracker_sparql_connection_query_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error_);
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (_data_->_inner_error_ != NULL) {
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_object_unref0 (_data_->cursor2);
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_object_unref0 (_data_->cursor1);
#line 1098 "test-class-signal.c"
			goto __catch2_g_error;
		}
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (_data_->cursor1);
#line 126 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->cursor1 = _data_->_tmp3_;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp4_ = _data_->self->priv->signal_con;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp5_ = _data_->ins_query;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_state_ = 2;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		tracker_sparql_connection_query_async (_data_->_tmp4_, _data_->_tmp5_, NULL, test_app_on_graph_updated_received_async_ready, _data_);
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return FALSE;
#line 1115 "test-class-signal.c"
		_state_2:
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp6_ = NULL;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp6_ = tracker_sparql_connection_query_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error_);
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (_data_->_inner_error_ != NULL) {
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_object_unref0 (_data_->cursor2);
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_object_unref0 (_data_->cursor1);
#line 1129 "test-class-signal.c"
			goto __catch2_g_error;
		}
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (_data_->cursor2);
#line 127 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->cursor2 = _data_->_tmp7_;
#line 129 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp8_ = _data_->cursor1;
#line 129 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp9_ = 0;
#line 129 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp9_ = test_app_iter_cursor (_data_->self, "delete of: ", _data_->_tmp8_);
#line 129 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->self->priv->res = _data_->_tmp9_;
#line 130 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp10_ = _data_->self->priv->res;
#line 130 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (_data_->_tmp10_ != (-1)) {
#line 131 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_data_->_tmp11_ = _data_->cursor2;
#line 131 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_data_->_tmp12_ = 0;
#line 131 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_data_->_tmp12_ = test_app_iter_cursor (_data_->self, "insert of: ", _data_->_tmp11_);
#line 131 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_data_->self->priv->res = _data_->_tmp12_;
#line 1156 "test-class-signal.c"
		}
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (_data_->cursor2);
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_object_unref0 (_data_->cursor1);
#line 1162 "test-class-signal.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->e = _data_->_inner_error_;
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_inner_error_ = NULL;
#line 134 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp13_ = _data_->e;
#line 134 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->_tmp14_ = _data_->_tmp13_->message;
#line 134 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_warning ("test-class-signal.vala:134: Couldn't iterate query results: %s", _data_->_tmp14_);
#line 135 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_data_->self->priv->res = -1;
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_g_error_free0 (_data_->e);
#line 1181 "test-class-signal.c"
	}
	__finally2:
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (_data_->_inner_error_ != NULL) {
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_clear_error (&_data_->_inner_error_);
#line 123 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return FALSE;
#line 1192 "test-class-signal.c"
	}
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (_data_->_state_ == 0) {
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1198 "test-class-signal.c"
	} else {
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1202 "test-class-signal.c"
	}
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_object_unref (_data_->_async_result);
#line 122 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return FALSE;
#line 1208 "test-class-signal.c"
}


static void test_app_on_graph_updated_received (TestApp* self, const gchar* class_name, Event* deletes, int deletes_length1, Event* inserts, int inserts_length1) {
	const gchar* _tmp0_;
	Event* _tmp1_;
	gint _tmp1__length1;
	GString* _tmp2_ = NULL;
	GString* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* dels_qry;
	const gchar* _tmp7_;
	Event* _tmp8_;
	gint _tmp8__length1;
	GString* _tmp9_ = NULL;
	GString* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* ins_qry;
#line 139 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (self != NULL);
#line 139 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (class_name != NULL);
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = class_name;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1_ = deletes;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1__length1 = deletes_length1;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp2_ = test_app_build_title_query (self, _tmp0_, _tmp1_, _tmp1__length1);
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp3_ = _tmp2_;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp4_ = _tmp3_->str;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp6_ = _tmp5_;
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_string_free0 (_tmp3_);
#line 140 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	dels_qry = _tmp6_;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp7_ = class_name;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp8_ = deletes;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp8__length1 = deletes_length1;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp9_ = test_app_build_title_query (self, _tmp7_, _tmp8_, _tmp8__length1);
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp10_ = _tmp9_;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp11_ = _tmp10_->str;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp13_ = _tmp12_;
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_string_free0 (_tmp10_);
#line 141 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	ins_qry = _tmp13_;
#line 143 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_on_graph_updated_received_async (self, dels_qry, ins_qry, NULL, NULL);
#line 139 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_free0 (ins_qry);
#line 139 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_free0 (dels_qry);
#line 1281 "test-class-signal.c"
}


static void test_app_insert_data (TestApp* self) {
	gint i = 0;
#line 146 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (self != NULL);
#line 1289 "test-class-signal.c"
	{
		gboolean _tmp0_;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		i = 0;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		_tmp0_ = TRUE;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		while (TRUE) {
#line 1298 "test-class-signal.c"
			gboolean _tmp1_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gchar* _tmp7_ = NULL;
			gchar* upqry;
			Resources* _tmp8_;
			const gchar* _tmp9_;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp1_ = _tmp0_;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			if (!_tmp1_) {
#line 1312 "test-class-signal.c"
				gint _tmp2_;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				_tmp2_ = i;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				i = _tmp2_ + 1;
#line 1318 "test-class-signal.c"
			}
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp0_ = FALSE;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp3_ = i;
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			if (!(_tmp3_ <= max_signals)) {
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
				break;
#line 1328 "test-class-signal.c"
			}
#line 150 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp4_ = i;
#line 150 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp5_ = i;
#line 150 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp6_ = i;
#line 150 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp7_ = g_strdup_printf ("DELETE { <%d> a rdfs:Resource } INSERT { <%d> a nmm:MusicPiece ; nie:t" \
"itle '%s %d' }", _tmp4_, _tmp5_, title_data, _tmp6_);
#line 150 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			upqry = _tmp7_;
#line 152 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp8_ = test_app_resources_object;
#line 152 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_tmp9_ = upqry;
#line 152 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			resources_sparql_update_async (_tmp8_, _tmp9_, NULL, NULL);
#line 149 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			_g_free0 (upqry);
#line 1348 "test-class-signal.c"
		}
	}
}


static gboolean test_app_in_mainloop (TestApp* self) {
	gboolean result = FALSE;
#line 160 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_insert_data (self);
#line 163 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	result = FALSE;
#line 163 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 1364 "test-class-signal.c"
}


static gboolean _test_app_in_mainloop_gsource_func (gpointer self) {
	gboolean result;
	result = test_app_in_mainloop (self);
#line 168 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 1373 "test-class-signal.c"
}


gint test_app_run (TestApp* self) {
	gint result = 0;
	GMainLoop* _tmp0_;
	GMainLoop* _tmp1_;
	gint _tmp2_;
#line 166 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 167 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = g_main_loop_new (NULL, FALSE);
#line 167 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 167 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv->loop = _tmp0_;
#line 168 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _test_app_in_mainloop_gsource_func, test_app_ref (self), test_app_unref);
#line 169 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1_ = self->priv->loop;
#line 169 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_main_loop_run (_tmp1_);
#line 170 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp2_ = self->priv->res;
#line 170 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	result = _tmp2_;
#line 170 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 1402 "test-class-signal.c"
}


static void value_test_app_init (GValue* value) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	value->data[0].v_pointer = NULL;
#line 1409 "test-class-signal.c"
}


static void value_test_app_free_value (GValue* value) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (value->data[0].v_pointer) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		test_app_unref (value->data[0].v_pointer);
#line 1418 "test-class-signal.c"
	}
}


static void value_test_app_copy_value (const GValue* src_value, GValue* dest_value) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (src_value->data[0].v_pointer) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		dest_value->data[0].v_pointer = test_app_ref (src_value->data[0].v_pointer);
#line 1428 "test-class-signal.c"
	} else {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1432 "test-class-signal.c"
	}
}


static gpointer value_test_app_peek_pointer (const GValue* value) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return value->data[0].v_pointer;
#line 1440 "test-class-signal.c"
}


static gchar* value_test_app_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (collect_values[0].v_pointer) {
#line 1447 "test-class-signal.c"
		TestApp* object;
		object = collect_values[0].v_pointer;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		if (object->parent_instance.g_class == NULL) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1454 "test-class-signal.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1458 "test-class-signal.c"
		}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = test_app_ref (object);
#line 1462 "test-class-signal.c"
	} else {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = NULL;
#line 1466 "test-class-signal.c"
	}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return NULL;
#line 1470 "test-class-signal.c"
}


static gchar* value_test_app_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TestApp** object_p;
	object_p = collect_values[0].v_pointer;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (!object_p) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1481 "test-class-signal.c"
	}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (!value->data[0].v_pointer) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		*object_p = NULL;
#line 1487 "test-class-signal.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		*object_p = value->data[0].v_pointer;
#line 1491 "test-class-signal.c"
	} else {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		*object_p = test_app_ref (value->data[0].v_pointer);
#line 1495 "test-class-signal.c"
	}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return NULL;
#line 1499 "test-class-signal.c"
}


GParamSpec* param_spec_test_app (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTestApp* spec;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TEST_APP), NULL);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return G_PARAM_SPEC (spec);
#line 1513 "test-class-signal.c"
}


gpointer value_get_test_app (const GValue* value) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP), NULL);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return value->data[0].v_pointer;
#line 1522 "test-class-signal.c"
}


void value_set_test_app (GValue* value, gpointer v_object) {
	TestApp* old;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	old = value->data[0].v_pointer;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (v_object) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_APP));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = v_object;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		test_app_ref (value->data[0].v_pointer);
#line 1542 "test-class-signal.c"
	} else {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = NULL;
#line 1546 "test-class-signal.c"
	}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (old) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		test_app_unref (old);
#line 1552 "test-class-signal.c"
	}
}


void value_take_test_app (GValue* value, gpointer v_object) {
	TestApp* old;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TEST_APP));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	old = value->data[0].v_pointer;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (v_object) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TEST_APP));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = v_object;
#line 1571 "test-class-signal.c"
	} else {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		value->data[0].v_pointer = NULL;
#line 1575 "test-class-signal.c"
	}
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (old) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		test_app_unref (old);
#line 1581 "test-class-signal.c"
	}
}


static void test_app_class_init (TestAppClass * klass) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	test_app_parent_class = g_type_class_peek_parent (klass);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	TEST_APP_CLASS (klass)->finalize = test_app_finalize;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_type_class_add_private (klass, sizeof (TestAppPrivate));
#line 1593 "test-class-signal.c"
}


static void test_app_instance_init (TestApp * self) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv = TEST_APP_GET_PRIVATE (self);
#line 45 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv->res = -1;
#line 47 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv->initialized = FALSE;
#line 50 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->priv->total_signals_seen = 0;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self->ref_count = 1;
#line 1608 "test-class-signal.c"
}


static void test_app_finalize (TestApp* obj) {
	TestApp * self;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	self = TEST_APP (obj);
#line 46 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 48 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_object_unref0 (self->priv->signal_con);
#line 49 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_g_object_unref0 (self->priv->con);
#line 1622 "test-class-signal.c"
}


GType test_app_get_type (void) {
	static volatile gsize test_app_type_id__volatile = 0;
	if (g_once_init_enter (&test_app_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_test_app_init, value_test_app_free_value, value_test_app_copy_value, value_test_app_peek_pointer, "p", value_test_app_collect_value, "p", value_test_app_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TestAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) test_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestApp), 0, (GInstanceInitFunc) test_app_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType test_app_type_id;
		test_app_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TestApp", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&test_app_type_id__volatile, test_app_type_id);
	}
	return test_app_type_id__volatile;
}


gpointer test_app_ref (gpointer instance) {
	TestApp* self;
	self = instance;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_atomic_int_inc (&self->ref_count);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return instance;
#line 1647 "test-class-signal.c"
}


void test_app_unref (gpointer instance) {
	TestApp* self;
	self = instance;
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		TEST_APP_GET_CLASS (self)->finalize (self);
#line 43 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1660 "test-class-signal.c"
	}
}


gint _vala_main (gchar** args, int args_length1) {
	gint result = 0;
	TestApp* _tmp0_;
	TestApp* app;
	gint _tmp1_ = 0;
#line 175 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp0_ = test_app_new ();
#line 175 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	app = _tmp0_;
#line 177 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_tmp1_ = test_app_run (app);
#line 177 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	result = _tmp1_;
#line 177 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	_test_app_unref0 (app);
#line 177 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return result;
#line 1682 "test-class-signal.c"
}


int main (int argc, char ** argv) {
#line 174 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	g_type_init ();
#line 174 "/home/martyn/Source/tracker/tests/functional-tests/ipc/test-class-signal.vala"
	return _vala_main (argv, argc);
#line 1691 "test-class-signal.c"
}



